HelpBot Assistant

How can I help you?

Scatter Chart in EJ2 JavaScript Charts

3 Feb 202624 minutes to read

Scatter Chart

To render a scatter series in your chart, you need to follow a few steps to configure it correctly. Here’s a concise guide on how to do this:

  • Set the series type: Define the series type as Scatter in your chart configuration. This indicates that the data should be displayed as individual points scattered across the chart.
var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 120; i++) {
    if (Math.random() > 0.5) {
        value += Math.random();
    } else {
        value -= Math.random();
    }
    value = value < 60 ? 60 : value > 90 ? 90 : value;
    point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
    series1.push(point1);
}
for (i = 1; i < 120; i++) {
    if (Math.random() > 0.5) {
        value1 += Math.random();
    } else {
        value1 -= Math.random();
    }
    value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
    point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
    series2.push(point1);
}

var chart = new ej.charts.Chart({
    primaryXAxis: {
        title: 'Height (cm)',
        minimum: 120, maximum: 180,
        edgeLabelPlacement: 'Shift',
        labelFormat: '{value}cm'
    },
    primaryYAxis:
    {
        title: 'Weight (kg)',
        minimum: 60, maximum: 90,
        labelFormat: '{value}kg',
        rangePadding: 'None'
    },
    series: [
        {
            //Series type as scatter
            type: 'Scatter',
            dataSource: series1, xName: 'x', yName: 'y',
            name: 'Male',
            marker: { width: 10, height: 10 }
        }, {
            type: 'Scatter',
            dataSource: series2, xName: 'x', yName: 'y',
            name: 'Female',
            marker: { width: 10, height: 10 }
        }
    ],
    title: 'Height Vs Weight'
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Binding data with series

You can bind data to the chart using the dataSource property within the series configuration. This allows you to connect a JSON dataset or remote data to your chart. To display the data correctly, map the fields from the data to the chart series xName and yName properties.

var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 120; i++) {
    if (Math.random() > 0.5) {
        value += Math.random();
    } else {
        value -= Math.random();
    }
    value = value < 60 ? 60 : value > 90 ? 90 : value;
    point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
    series1.push(point1);
}
for (i = 1; i < 120; i++) {
    if (Math.random() > 0.5) {
        value1 += Math.random();
    } else {
        value1 -= Math.random();
    }
    value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
    point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
    series2.push(point1);
}

var chart = new ej.charts.Chart({
    primaryXAxis: {
        title: 'Height (cm)',
        minimum: 120, maximum: 180,
        edgeLabelPlacement: 'Shift',
        labelFormat: '{value}cm'
    },
    primaryYAxis:
    {
        title: 'Weight (kg)',
        minimum: 60, maximum: 90,
        labelFormat: '{value}kg',
        rangePadding: 'None'
    },
    series: [
        {
            //Series type as scatter
            type: 'Scatter',
            dataSource: series1, xName: 'x', yName: 'y',
            name: 'Male',
            marker: { width: 10, height: 10 }
        }, {
            type: 'Scatter',
            dataSource: series2, xName: 'x', yName: 'y',
            name: 'Female',
            marker: { width: 10, height: 10 }
        }
    ],
    title: 'Height Vs Weight'
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Series customization

The following properties can be used to customize the scatter series.

Fill

The fill property determines the color applied to the series.

var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value += Math.random();
  } else {
    value -= Math.random();
  }
  value = value < 60 ? 60 : value > 90 ? 90 : value;
  point1 = { x: 120 + i / 2, y: value.toFixed(1) };
  series1.push(point1);
}
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value1 += Math.random();
  } else {
    value1 -= Math.random();
  }
  value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
  point1 = { x: 120 + i / 2, y: value1.toFixed(1) };
  series2.push(point1);
}

var chart = new ej.charts.Chart(
  {
    primaryXAxis: {
      title: 'Height (cm)',
      minimum: 120,
      maximum: 180,
      edgeLabelPlacement: 'Shift',
      labelFormat: '{value}cm'
    },
    primaryYAxis: {
      title: 'Weight (kg)',
      minimum: 60,
      maximum: 90,
      labelFormat: '{value}kg',
      rangePadding: 'None'
    },
    series: [
      {
        type: 'Scatter',
        dataSource: series1,
        xName: 'x',
        yName: 'y',
        name: 'Male',
        marker: { width: 5, height: 5 }
      },
      {
        type: 'Scatter',
        dataSource: series2,
        xName: 'x',
        yName: 'y',
        name: 'Female',
        fill: 'red',
        marker: { width: 3, height: 3 }
      }
    ],
    title: 'Height Vs Weight'
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Opacity

The opacity property controls the transparency of the fill and affects how the series blends with background or overlapping series.

var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value += Math.random();
  } else {
    value -= Math.random();
  }
  value = value < 60 ? 60 : value > 90 ? 90 : value;
  point1 = { x: 120 + i / 2, y: value.toFixed(1) };
  series1.push(point1);
}
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value1 += Math.random();
  } else {
    value1 -= Math.random();
  }
  value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
  point1 = { x: 120 + i / 2, y: value1.toFixed(1) };
  series2.push(point1);
}

var chart = new ej.charts.Chart(
  {
    primaryXAxis: {
      title: 'Height (cm)',
      minimum: 120,
      maximum: 180,
      edgeLabelPlacement: 'Shift',
      labelFormat: '{value}cm'
    },
    primaryYAxis: {
      title: 'Weight (kg)',
      minimum: 60,
      maximum: 90,
      labelFormat: '{value}kg',
      rangePadding: 'None'
    },
    series: [
      {
        type: 'Scatter',
        dataSource: series1,
        xName: 'x',
        yName: 'y',
        name: 'Male',
        opacity: 0.7,
        marker: { width: 5, height: 5 }
      },
      {
        type: 'Scatter',
        dataSource: series2,
        xName: 'x',
        yName: 'y',
        name: 'Female',
        opacity: 0.7,
        fill: 'red',
        marker: { width: 3, height: 3 }
      }
    ],
    title: 'Height Vs Weight'
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Shape

The shape property allows you to customize the appearance of the markers by specifying different shapes.

var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value += Math.random();
  } else {
    value -= Math.random();
  }
  value = value < 60 ? 60 : value > 90 ? 90 : value;
  point1 = { x: 120 + i / 2, y: value.toFixed(1) };
  series1.push(point1);
}
for (i = 1; i < 120; i++) {
  if (Math.random() > 0.5) {
    value1 += Math.random();
  } else {
    value1 -= Math.random();
  }
  value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
  point1 = { x: 120 + i / 2, y: value1.toFixed(1) };
  series2.push(point1);
}

var chart = new ej.charts.Chart(
  {
    primaryXAxis: {
      title: 'Height (cm)',
      minimum: 120,
      maximum: 180,
      edgeLabelPlacement: 'Shift',
      labelFormat: '{value}cm'
    },
    primaryYAxis: {
      title: 'Weight (kg)',
      minimum: 60,
      maximum: 90,
      labelFormat: '{value}kg',
      rangePadding: 'None'
    },
    series: [
      {
        type: 'Scatter',
        dataSource: series1,
        xName: 'x',
        yName: 'y',
        name: 'Male',
        opacity: 0.7,
        marker: { width: 5, height: 5, shape: 'Triangle' }
      },
      {
        type: 'Scatter',
        dataSource: series2,
        xName: 'x',
        yName: 'y',
        name: 'Female',
        opacity: 0.7,
        fill: 'red',
        marker: { width: 3, height: 3, shape: 'Square' }
      }
    ],
    title: 'Height Vs Weight'
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Border

Use the border property to configure the border width, color, and dasharray of the scatter series.

var series1 = [];
var series2 = [];
var point1;
var value = 80;
var value1 = 70;
var i;
for (i = 1; i < 8; i++) {
  if (Math.random() > 0.5) {
    value += Math.random();
  } else {
    value -= Math.random();
  }
  value = value < 60 ? 60 : value > 90 ? 90 : value;
  point1 = { x: 120 + i / 2, y: value.toFixed(1) };
  series1.push(point1);
}
for (i = 1; i < 8; i++) {
  if (Math.random() > 0.5) {
    value1 += Math.random();
  } else {
    value1 -= Math.random();
  }
  value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
  point1 = { x: 120 + i / 2, y: value1.toFixed(1) };
  series2.push(point1);
}

var chart = new ej.charts.Chart(
  {
    primaryXAxis: {
      title: 'Height (cm)',
      edgeLabelPlacement: 'Shift',
      labelFormat: '{value}cm'
    },
    primaryYAxis: {
      title: 'Weight (kg)',
      minimum: 60,
      maximum: 90,
      labelFormat: '{value}kg',
      rangePadding: 'None'
    },
    series: [
      {
        type: 'Scatter',
        dataSource: series1,
        xName: 'x',
        yName: 'y',
        name: 'Male',
        opacity: 0.7,
        border: { width: 2, color: 'red' },
        marker: { width: 22, height: 22, shape: 'Circle' },
      },
      {
        type: 'Scatter',
        dataSource: series2,
        xName: 'x',
        yName: 'y',
        name: 'Female',
        opacity: 0.7,
        fill: 'red',
        border: { width: 2, color: 'Blue', dashArray: '15,2' },
        marker: { width: 22, height: 22, shape: 'Circle' },
      }
    ],
    title: 'Height Vs Weight'
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Empty points

Data points with null or undefined values are considered empty. Empty data points are ignored and not plotted on the chart.

Mode

Use the mode property to control handling of empty points. Available modes: Gap, Drop, Zero, Average. The default mode is Gap.

var scatterData = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

var chart = new ej.charts.Chart({
    primaryXAxis: {
        minimum: 0,
        maximum: 21,
        interval: 3,
        majorGridLines: { width: 0 },
        title: 'Study Hours (Per Week)'
    },
    primaryYAxis:
    {
        title: 'Test Scores (%)',
        minimum: 0,
        maximum: 120,
        interval: 20,
        labelFormat: '{value}%'
    },
    series: [
        {
            type: 'Scatter',
            dataSource: scatterData,
            xName: 'x',
            yName: 'y', 
            marker: {
                visible: false,
                width: 10,
                height: 10,
                shape: 'Circle'
            },
            emptyPointSettings: {
                mode: 'Zero'
            }
        }
    ],
    title: 'Relationship Between Study Hours and Test Scores'
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Fill

Use the fill property to set the fill color for empty points.

var scatterData = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

var chart = new ej.charts.Chart({
    primaryXAxis: {
        minimum: 0,
        maximum: 21,
        interval: 3,
        majorGridLines: { width: 0 },
        title: 'Study Hours (Per Week)'
    },
    primaryYAxis:
    {
        title: 'Test Scores (%)',
        minimum: 0,
        maximum: 120,
        interval: 20,
        labelFormat: '{value}%'
    },
    series: [
        {
            type: 'Scatter',
            dataSource: scatterData,
            xName: 'x',
            yName: 'y', 
            marker: {
                visible: false,
                width: 10,
                height: 10,
                shape: 'Circle'
            },
            emptyPointSettings: {
                mode: 'Average',
                fill: 'red'
            }
        }
    ],
    title: 'Relationship Between Study Hours and Test Scores'
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Border

Use the border property to customize the border width and color for empty points.

var scatterData = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

var chart = new ej.charts.Chart({
    primaryXAxis: {
        minimum: 0,
        maximum: 21,
        interval: 3,
        majorGridLines: { width: 0 },
        title: 'Study Hours (Per Week)'
    },
    primaryYAxis:
    {
        title: 'Test Scores (%)',
        minimum: 0,
        maximum: 120,
        interval: 20,
        labelFormat: '{value}%'
    },
    series: [
        {
            type: 'Scatter',
            dataSource: scatterData,
            xName: 'x',
            yName: 'y', 
            marker: {
                visible: false,
                width: 10,
                height: 10,
                shape: 'Circle'
            },
            emptyPointSettings: {
                mode: 'Average',
                fill: 'red',
                border: { width: 2, color: 'green' }
            }
        }
    ],
    title: 'Relationship Between Study Hours and Test Scores'
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Events

Series render

The seriesRender event enables modification of series properties (for example, data, fill, or name) immediately before rendering. Use this event to adjust series appearance or to dynamically swap data sources.

var scatterData = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: 45 },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: 85 },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: 97 },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

var chart = new ej.charts.Chart({
    primaryXAxis: {
        minimum: 0,
        maximum: 21,
        interval: 3,
        majorGridLines: { width: 0 },
        title: 'Study Hours (Per Week)'
    },
    primaryYAxis:
    {
        title: 'Test Scores (%)',
        minimum: 0,
        maximum: 120,
        interval: 20,
        labelFormat: '{value}%'
    },
    series: [
        {
            type: 'Scatter',
            dataSource: scatterData,
            xName: 'x',
            yName: 'y', 
            marker: {
                visible: false,
                width: 10,
                height: 10,
                shape: 'Circle'
            }
        }
    ],
    title: 'Relationship Between Study Hours and Test Scores',
    seriesRender: function (args) {
        args.fill = '#ff6347';
    }
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Point render

The pointRender event provides a hook to customize each data point (for example, marker shape, border, or fill) before it is drawn. Use this to apply per-point styling rules or conditional formatting.

var scatterData = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: 45 },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: 85 },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: 97 },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

var chart = new ej.charts.Chart({
    primaryXAxis: {
        minimum: 0,
        maximum: 21,
        interval: 3,
        majorGridLines: { width: 0 },
        title: 'Study Hours (Per Week)'
    },
    primaryYAxis:
    {
        title: 'Test Scores (%)',
        minimum: 0,
        maximum: 120,
        interval: 20,
        labelFormat: '{value}%'
    },
    series: [
        {
            type: 'Scatter',
            dataSource: scatterData,
            xName: 'x',
            yName: 'y', 
            marker: {
                visible: false,
                width: 10,
                height: 10,
                shape: 'Circle'
            }
        }
    ],
    title: 'Relationship Between Study Hours and Test Scores',
    pointRender: function (args) {
        if (args.point.index % 2 !== 0) {
            args.fill = '#ff6347';
        }
        else {
            args.fill = '#009cb8';
        }
    }
}, '#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Animation</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/33.1.44/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="element"></div>
    </div>
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

See also

HelpBot Assistant

How can I help you?

Scatter Chart in Angular Charts

3 Feb 202624 minutes to read

Scatter

To render a scatter series in your chart, you need to follow a few steps to configure it correctly. Here’s a concise guide on how to do this:

  1. Set the series type: Define the series type as Scatter in your chart configuration. This indicates that the data should be displayed as individual points scattered across the chart.

  2. Inject the ScatterSeries module: Use the @NgModule.providers method to inject the ScatterSeriesService module into your chart. This step is essential, as it ensures that the necessary functionalities for rendering the scatter series are available in your chart.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='series1' type='Scatter' xName='x' yName='y' name='Male' opacity=0.7 [marker]='marker'></e-series>
            <e-series [dataSource]='series2' type='Scatter' xName='x' yName='y' name='Female' opacity=0.7 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public series1?: Object;
    public series2?: Object;
    public marker?: Object;
    getScatterData(): any {
        let series1: Object[] = [];
        let series2: Object[] = [];
        let point1: Object;
        let value: number = 80;
        let value1: number = 70;
        let i: number;
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value += Math.random();
            } else {
                value -= Math.random();
            }
            value = value < 60 ? 60 : value > 90 ? 90 : value;
            point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
            series1.push(point1);
        }
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value1 += Math.random();
            } else {
                value1 -= Math.random();
            }
            value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
            point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
            series2.push(point1);
        }
        return { 'series1':series1, 'series2': series2};
    };
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            minimum: 120, maximum: 180,
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            minimum: 60, maximum: 90,
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.series1 = this.getScatterData().series1;
        this.series2 = this.getScatterData().series2;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Binding data with series

You can bind data to the chart using the dataSource property within the series configuration. This allows you to connect a JSON dataset or remote data to your chart. To display the data correctly, map the fields from the data to the chart series xName and yName properties.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='series1' type='Scatter' xName='x' yName='y' name='Male' opacity=0.7 [marker]='marker'></e-series>
            <e-series [dataSource]='series2' type='Scatter' xName='x' yName='y' name='Female' opacity=0.7 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public series1?: Object;
    public series2?: Object;
    public marker?: Object;
    getScatterData(): any {
        let series1: Object[] = [];
        let series2: Object[] = [];
        let point1: Object;
        let value: number = 80;
        let value1: number = 70;
        let i: number;
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value += Math.random();
            } else {
                value -= Math.random();
            }
            value = value < 60 ? 60 : value > 90 ? 90 : value;
            point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
            series1.push(point1);
        }
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value1 += Math.random();
            } else {
                value1 -= Math.random();
            }
            value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
            point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
            series2.push(point1);
        }
        return { 'series1':series1, 'series2': series2};
    };
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            minimum: 120, maximum: 180,
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            minimum: 60, maximum: 90,
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.series1 = this.getScatterData().series1;
        this.series2 = this.getScatterData().series2;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Series customization

The following properties can be used to customize the scatter series.

Fill

Use the fill property to set the fill color for empty points.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='series1' type='Scatter' xName='x' yName='y' name='Male' fill='orange'></e-series>
            <e-series [dataSource]='series2' type='Scatter' xName='x' yName='y' name='Female' fill='red'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public series1?: Object;
    public series2?: Object;
    getScatterData(): any {
        let series1: Object[] = [];
        let series2: Object[] = [];
        let point1: Object;
        let value: number = 80;
        let value1: number = 70;
        let i: number;
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value += Math.random();
            } else {
                value -= Math.random();
            }
            value = value < 60 ? 60 : value > 90 ? 90 : value;
            point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
            series1.push(point1);
        }
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value1 += Math.random();
            } else {
                value1 -= Math.random();
            }
            value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
            point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
            series2.push(point1);
        }
        return { 'series1':series1, 'series2': series2};
    };
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            minimum: 120, maximum: 180,
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            minimum: 60, maximum: 90,
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.series1 = this.getScatterData().series1;
        this.series2 = this.getScatterData().series2;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Opacity

The opacity property controls the transparency of the fill and affects how the series blends with background or overlapping series.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='series1' type='Scatter' xName='x' yName='y' name='Male' opacity=0.7 [marker]='marker'></e-series>
            <e-series [dataSource]='series2' type='Scatter' xName='x' yName='y' name='Female' opacity=0.7 [marker]='marker'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public series1?: Object;
    public series2?: Object;
    public marker?: Object;
    getScatterData(): any {
        let series1: Object[] = [];
        let series2: Object[] = [];
        let point1: Object;
        let value: number = 80;
        let value1: number = 70;
        let i: number;
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value += Math.random();
            } else {
                value -= Math.random();
            }
            value = value < 60 ? 60 : value > 90 ? 90 : value;
            point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
            series1.push(point1);
        }
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value1 += Math.random();
            } else {
                value1 -= Math.random();
            }
            value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
            point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
            series2.push(point1);
        }
        return { 'series1':series1, 'series2': series2};
    };
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            minimum: 120, maximum: 180,
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            minimum: 60, maximum: 90,
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.series1 = this.getScatterData().series1;
        this.series2 = this.getScatterData().series2;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Shape

The shape property allows you to customize the appearance of the markers by specifying different shapes.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='series1' type='Scatter' xName='x' yName='y' name='Male' [marker]='marker'></e-series>
            <e-series [dataSource]='series2' type='Scatter' xName='x' yName='y' name='Female' [marker]='marker1'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public series1?: Object;
    public series2?: Object;
    public marker?: Object;
    public marker1?: Object;
    getScatterData(): any {
        let series1: Object[] = [];
        let series2: Object[] = [];
        let point1: Object;
        let value: number = 80;
        let value1: number = 70;
        let i: number;
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value += Math.random();
            } else {
                value -= Math.random();
            }
            value = value < 60 ? 60 : value > 90 ? 90 : value;
            point1 = { x: 120 + (i / 2), y: value.toFixed(1) };
            series1.push(point1);
        }
        for (i = 1; i < 120; i++) {
            if (Math.random() > 0.5) {
                value1 += Math.random();
            } else {
                value1 -= Math.random();
            }
            value1 = value1 < 60 ? 60 : value1 > 90 ? 90 : value1;
            point1 = { x: 120 + (i / 2), y: value1.toFixed(1) };
            series2.push(point1);
        }
        return { 'series1':series1, 'series2': series2};
    };
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            minimum: 120, maximum: 180,
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            minimum: 60, maximum: 90,
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.marker1 = {  width: 10, height: 10, shape: 'Rectangle' };
        this.series1 = this.getScatterData().series1;
        this.series2 = this.getScatterData().series2;
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Empty points

Data points with null or undefined values are considered empty. Empty data points are ignored and not plotted on the chart.

Mode

Use the mode property to control handling of empty points. Available modes: Gap, Drop, Zero, Average. The default mode is Gap.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { scatterData } from './datasource';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Scatter' xName='x' yName='y' name='Male' [emptyPointSettings]='emptyPointSettings'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public emptyPointSettings?: Object;
    public marker?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.chartData = scatterData;
        this.emptyPointSettings = {
            mode: 'Zero'
        }
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
export let scatterData: Object[] = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

Fill

Use the fill property to customize the fill color of empty points in the series.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { scatterData } from './datasource';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Scatter' xName='x' yName='y' name='Male' '[emptyPointSettings]='emptyPointSettings'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public emptyPointSettings?: Object;
    public marker?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.chartData = scatterData;
        this.emptyPointSettings = {
            mode: 'Average', fill: 'red'
        }
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
export let scatterData: Object[] = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

Border

Use the border property to configure the border width, color, and dasharray of the scatter series.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { scatterData } from './datasource';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Scatter' xName='x' yName='y' name='Male' [emptyPointSettings]='emptyPointSettings'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public emptyPointSettings?: Object;
    public marker?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.chartData = scatterData;
        this.emptyPointSettings = {
            mode: 'Average', fill: 'red', border: { width: 2, color: 'green' }
        }
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
export let scatterData: Object[] = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: null },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: undefined },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: null },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

Events

Series render

The seriesRender event enables modification of series properties (for example, data, fill, or name) immediately before rendering. Use this event to adjust series appearance or to dynamically swap data sources.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { ISeriesRenderEventArgs } from '@syncfusion/ej2-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { scatterData } from './datasource';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" (seriesRender)='seriesRender($event)' [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Scatter' xName='x' yName='y' name='Male'></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public emptyPointSettings?: Object;
    public marker?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.chartData = scatterData;
    }
    public seriesRender(args: ISeriesRenderEventArgs)  {
      
            args.fill = '#ff6347';
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
export let scatterData: Object[] = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: 45 },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: 85 },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: 97 },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

Point render

The pointRender event provides a hook to customize each data point (for example, marker shape, border, or fill) before it is drawn. Use this to apply per-point styling rules or conditional formatting.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { ChartModule } from '@syncfusion/ej2-angular-charts'
import { IPointRenderEventArgs } from '@syncfusion/ej2-charts'
import { ScatterSeriesService, LegendService} from '@syncfusion/ej2-angular-charts'
import { Component, OnInit } from '@angular/core';
import { scatterData } from './datasource';

@Component({
imports: [
         ChartModule
    ],

providers: [ ScatterSeriesService, LegendService],
standalone: true,
    selector: 'app-container',
    template: `<ejs-chart id="chart-container" (pointRender)='pointRender($event)' [primaryXAxis]='primaryXAxis'[primaryYAxis]='primaryYAxis' [title]='title'>
        <e-series-collection>
            <e-series [dataSource]='chartData' type='Scatter' xName='x' yName='y' name='Male' ></e-series>
        </e-series-collection>
    </ejs-chart>`
})
export class AppComponent implements OnInit {
    public primaryXAxis?: Object;
    public chartData?: Object[];
    public title?: string;
    public primaryYAxis?: Object;
    public emptyPointSettings?: Object;
    public marker?: Object;
    ngOnInit(): void {
        this.primaryXAxis = {
            title: 'Height (cm)',
            edgeLabelPlacement: 'Shift',
            labelFormat: '{value}cm'
        };
        this.primaryYAxis = {
            title: 'Weight (kg)',
            labelFormat: '{value}kg',
            rangePadding: 'None'
        };
        this.title = 'Height Vs Weight';
        this.marker = {  width: 10, height: 10 };
        this.chartData = scatterData;
    }
    public pointRender(args: IPointRenderEventArgs)  {
        if (args.point.index % 2 !== 0) {
            args.fill = '#ff6347';
        }
        else {
            args.fill = '#009cb8';
        }
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));
export let scatterData: Object[] = [
    { x: 1, y: 15 },
    { x: 2, y: 25 },
    { x: 3, y: 35 },
    { x: 4, y: 45 },
    { x: 5, y: 55 },
    { x: 6, y: 60 },
    { x: 7, y: 65 },
    { x: 8, y: 70 },
    { x: 9, y: 75 },
    { x: 10, y: 80 },
    { x: 11, y: 85 },
    { x: 12, y: 90 },
    { x: 13, y: 92 },
    { x: 14, y: 94 },
    { x: 15, y: 96 },
    { x: 16, y: 97 },
    { x: 17, y: 98 },
    { x: 18, y: 99 },
    { x: 19, y: 100 },
    { x: 20, y: 100 }
];

See Also

HelpBot Assistant

How can I help you?

Scatter Chart in React Charts

24 Feb 202624 minutes to read

Scatter

To render a scatter series in your chart, you need to follow a few steps to configure it correctly. Here’s a concise guide on how to do this:

  1. Set the series type: Define the series type as Scatter in your chart configuration. This indicates that the data should be displayed as individual points scattered across the chart.

  2. Inject the ScatterSeries module: Inject ScatterSeries module into the services. This step is essential, as it ensures that the necessary functionalities for rendering the scatter series are available in your chart.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';
function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker = { width: 15, height: 15 };
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' name='Male' type='Scatter' marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' name='Female' type='Scatter' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker = { width: 15, height: 15 };

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' name='Male' type='Scatter'
          marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' name='Female' type='Scatter'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Binding data with series

You can bind data to the chart using the dataSource property within the series configuration. This allows you to connect a JSON dataset or remote data to your chart. To display the data correctly, map the fields from the data to the chart series xName and yName properties.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';
function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker = { width: 15, height: 15 };
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' name='Male' type='Scatter' marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' name='Female' type='Scatter' marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker = { width: 15, height: 15 };

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' name='Male' type='Scatter'
          marker={marker}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' name='Female' type='Scatter'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Series customization

The following properties can be used to customize the scatter series.

Fill

The fill property determines the color applied to the series.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10, shape: 'Triangle' };
    const marker = { width: 12, height: 12, shape: 'Rectangle'};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' fill='red'
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter' fill='yellow'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10, shape: 'Triangle' };
  const marker = { width: 12, height: 12, shape: 'Rectangle'};

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' fill='red'
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter' fill='yellow'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Opacity

The opacity property controls the transparency of the fill and affects how the series blends with background or overlapping series.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10, shape: 'Triangle' };
    const marker = { width: 12, height: 12, shape: 'Rectangle'};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' opacity={0.4}
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter' opacity={0.4}
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10, shape: 'Triangle' };
  const marker = { width: 12, height: 12, shape: 'Rectangle'};

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' opacity={0.4}
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter' opacity={0.4}
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Shape

The shape property allows you to customize the appearance of the markers by specifying different shapes.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10, shape: 'Star' };
    const marker = { width: 12, height: 12, shape: 'Circle'};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter'
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10, shape: 'Star' };
  const marker = { width: 12, height: 12, shape: 'Circle'};

  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' opacity={0.4}
          marker={marker1}>
        </SeriesDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='female' type='Scatter' opacity={0.4}
          marker={marker}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Empty points

Data points with null or undefined values are considered empty. Empty data points are ignored and not plotted on the chart.

Mode

Use the mode property to control handling of empty points. Available modes: Gap, Drop, Zero, Average. The default mode is Gap.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10 };
    const emptyPoint = { mode: 'Gap'};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10};
  const emptyPoint = { mode: 'Gap'};
  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Fill

Use the fill property to set the fill color for empty points.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10 };
    const emptyPoint = { mode: 'Average', fill: 'red'};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10};
  const emptyPoint = { mode: 'Average', fill: 'red'};
  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' 
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Border

Use the border property to customize the border width and color for empty points.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10 };
    const emptyPoint = { mode: 'Average', fill: 'red', border: {width:1.5, color: 'green'}};
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, Marker}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10};
  const emptyPoint = {  mode: 'Average', fill: 'red', border: {width:1.5, color: 'green'}};
  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight'>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' 
          marker={marker1} emptyPointSettings={emptyPoint}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: null, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: undefined, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Events

Series render

The seriesRender event enables modification of series properties (for example, data, fill, or name) immediately before rendering. Use this event to adjust series appearance or to dynamically swap data sources.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10 };
    const seriesRender = (args) => {
      args.fill = '#ff6347';
  }
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight' seriesRender={seriesRender}>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} >
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, ISeriesRenderEventArgs}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10};
  const seriesRender = (args: ISeriesRenderEventArgs) => {
    args.fill = '#ff6347';
}
  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight' seriesRender={seriesRender}>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' 
          marker={marker1}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

Point render

The pointRender event provides a hook to customize each data point (for example, marker shape, border, or fill) before it is drawn. Use this to apply per-point styling rules or conditional formatting.

import * as React from "react";
import * as ReactDOM from "react-dom";
import { ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject, Legend, Category, Tooltip, DataLabel, ScatterSeries } from '@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
    const primaryxAxis = {
        title: 'Height (cm)', minimum: 130, maximum: 180,
        edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
    };
    const primaryyAxis = {
        title: 'Weight (kg)', minimum: 30, maximum: 100,
        labelFormat: '{value}kg', rangePadding: 'None'
    };
    const marker1 = { width: 10, height: 10 };
    const pointRender = (args) => {
      if (args.point.index % 2 !== 0) {
        args.fill = '#ff6347';
    }
    else {
        args.fill = '#009cb8';
    }
  }
    return <ChartComponent id='charts' primaryXAxis={primaryxAxis} primaryYAxis={primaryyAxis} title='Height Vs Weight' pointRender={pointRender}>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]}/>
      <SeriesCollectionDirective>
      <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter'
          marker={marker1} >
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AxisModel, ChartComponent, SeriesCollectionDirective, SeriesDirective, Inject,
         Legend, Category, Tooltip, DataLabel, ScatterSeries, IPointRenderEventArgs}
from'@syncfusion/ej2-react-charts';
import { scatterData } from './datasource';

function App() {
  const primaryxAxis: AxisModel = {
    title: 'Height (cm)', minimum: 130, maximum: 180,
    edgeLabelPlacement: 'Shift', labelFormat: '{value}cm'
  };
  const primaryyAxis: AxisModel = {
    title: 'Weight (kg)', minimum: 30, maximum: 100,
    labelFormat: '{value}kg', rangePadding: 'None'
  };
  const marker1 = { width: 10, height: 10};
  const pointRender = (args: IPointRenderEventArgs) => {
    if (args.point.index % 2 !== 0) {
      args.fill = '#ff6347';
  }
  else {
      args.fill = '#009cb8';
  }
}
  return <ChartComponent id='charts'
      primaryXAxis={primaryxAxis}
      primaryYAxis={primaryyAxis}
      title='Height Vs Weight' pointRender={pointRender}>
      <Inject services={[ScatterSeries, Legend, Tooltip, DataLabel, Category]} />
      <SeriesCollectionDirective>
        <SeriesDirective dataSource={scatterData} xName='height' yName='male' type='Scatter' 
          marker={marker1}>
        </SeriesDirective>
      </SeriesCollectionDirective>
    </ChartComponent>
  
};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let scatterData = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];
export let scatterData: Object[] = [
    { height: 130, male: 35, female: 32 },
    { height: 132, male: 38, female: 33 },
    { height: 135, male: 41, female: 38 },
    { height: 137, male: 43, female: 40 },
    { height: 140, male: 45, female: 42 },
    { height: 142, male: 46, female: 42.5 },
    { height: 145, male: 48, female: 43 },
    { height: 147, male: 50, female: 44 },
    { height: 150, male: 52, female: 45 },
    { height: 152, male: 55, female: 45 },
    { height: 155, male: 58, female: 46 },
    { height: 157, male: 60, female: 48 },
    { height: 160, male: 63, female: 51 },
    { height: 162, male: 70, female: 54 },
    { height: 165, male: 75, female: 58 },
    { height: 167, male: 78, female: 62 },
    { height: 170, male: 82, female: 68 },
    { height: 172, male: 87, female: 72 },
    { height: 175, male: 89, female: 78 },
    { height: 177, male: 92, female: 82 },
    { height: 180, male: 95, female: 85 }
];

See Also